
#pragma once

#include "acfg.h"
#include "pmf.h"
#include "obitstream.h"


class AEnc
{
public:
  AEnc  ( const ACfg& acfg, std::string& outname );
  ~AEnc ();

  bool      isValid       ()                                const { return valid; }
  uint32_t  getNumEncoded ()                                const { return numEncoded; }
  void      encode        ( uint8_t index, const Pmf& pmf );
  void      terminate     ();

private:
	uint64_t c_v ( uint8_t index, const Pmf& pmf);
	uint64_t find_z ();
	void update_output();
	void pushBits( uint64_t c, bool isInverted);

private:
  //--- general variables ---
  const bool			  prefix;
  const uint32_t		  V;
  const uint32_t		  U;
  OBitstream			  bitstream;
  bool					  valid;
  uint32_t				  numEncoded;

  //--- members for arithmetic coding engine ---
  uint64_t		  A;
  uint64_t		  B;
  uint64_t		  C;
  uint64_t		  A_temp;
  uint64_t		  B_temp;
  uint64_t		  z;
  uint64_t		  n;
};
