
#include <cstdint>
#include <fstream>
#include <iostream>
#include "compare.h"


bool compare( const std::string& name1, const std::string& name2 )
{
  std::ifstream file1 ( name1, std::ios::binary );
  std::ifstream file2 ( name2, std::ios::binary );
  if( !file1.is_open() )
  {
    std::cerr << "\nERROR: Could not open file \"" << name1 << "\"\n";
    return true;
  }
  if( !file2.is_open() )
  {
    std::cerr << "\nERROR: Could not open file \"" << name2 << "\"\n";
    return true;
  }

  int64_t diff    = -1;
  int64_t numRead =  0;
  while( diff < 0 )
  {
    int char1 = file1.get();
    int char2 = file2.get();
    if( char1 != char2 )
    {
      diff = numRead;
    }
    if( char1 == std::char_traits<char>::eof() || char2 == std::char_traits<char>::eof() )
    {
      break;
    }
    numRead++;
  }

  if( diff >= 0 )
  {
    std::cout << "\nFiles \"" << name1 << "\" and \"" << name2 << "\" differ in byte " << numRead << "\n\n";
  }
  else
  {
    std::cout << "\nFiles \"" << name1 << "\" and \"" << name2 << "\" are identical (" << numRead << " bytes)\n\n";
  }
  return false;
}
