
#include "pmf.h"


Pmf4Fixed::Pmf4Fixed( uint32_t V )
{
  assert( V >= 4 && V <= 32 );
  uint32_t ls = V - 4;
  pmfQuant[0] = 6 << ls;
  pmfQuant[1] = 5 << ls;
  pmfQuant[2] = 3 << ls;
  pmfQuant[3] = 2 << ls;
}

Pmf256Fixed::Pmf256Fixed( uint32_t V )
{
  assert( V >= 8 && V <= 32 );
  uint32_t iv = 1 << ( V - 8 );
  for( int k = 0; k < 256; k++ )
  {
    pmfQuant[k] = iv;
  }
}

Pmf3Fixed::Pmf3Fixed(uint32_t V)
{
	assert(V >= 4 && V <= 32);
	uint32_t ls = V - 4;
	pmfQuant[0] = 8 << ls;
	pmfQuant[1] = 5 << ls;
	pmfQuant[2] = 3 << ls;
}

Pmf256Adaptive::Pmf256Adaptive( uint32_t Vbits )
{
  assert( Vbits >= 8 && Vbits <= 32 );
  V = Vbits;
  for( int k = 0; k < 256; k++ )
  {
    count[k] = 1;
  }
  totalcount = 256;
}

void Pmf256Adaptive::update( uint8_t index)
{
  count[index]++;
  totalcount++;
  if (totalcount >= ((uint64_t)1<<V))
  {
    totalcount = 0;
    for (uint8_t i = 0; i < 256; i++)
    {
      count[i] = (count[i] + 1) >> 1;
      totalcount += count[i];
    }
  }
}
