
#pragma once

#include <cstdint>
#include <cassert>


class Pmf
{
public:
  virtual ~Pmf() {}
  virtual uint64_t operator[] ( uint8_t index ) const = 0;
  virtual void     update     ( uint8_t index )       = 0;
};


class Pmf4Fixed : public Pmf
{
public:
  Pmf4Fixed             ( uint32_t Vbits );
  uint64_t  operator[]  ( uint8_t  index ) const { assert(index<4); return pmfQuant[index]; }
  void      update      ( uint8_t  index )       {}
private:
  uint64_t  pmfQuant[4];
};


class Pmf256Fixed : public Pmf
{
public:
  Pmf256Fixed           ( uint32_t Vbits );
  uint64_t  operator[]  ( uint8_t  index ) const { return pmfQuant[index]; }
  void      update      ( uint8_t  index )       {}
private:
  uint64_t  pmfQuant[256];
};


class Pmf3Fixed : public Pmf
{
public:
	Pmf3Fixed(uint32_t Vbits);
	uint64_t  operator[]  (uint8_t  index) const { assert(index < 3); return pmfQuant[index]; }
	void      update(uint8_t  index) {}
private:
	uint64_t  pmfQuant[3];
};

class Pmf256Adaptive : public Pmf
{
public:
  Pmf256Adaptive           ( uint32_t Vbits );
  uint64_t  operator[]  ( uint8_t  index ) const { return (count[index] << V)/totalcount; }
  void update(uint8_t index);
private:
  uint64_t count[256];
  uint64_t totalcount;
  uint8_t V;
};
