
#include <cstdlib>
#include <random>
#include <iostream>

int main( const int argc, const char** argv )
{
  int numSamples = 0;
  if( argc > 1 )
  {
    numSamples = std::atoi( argv[1] );
  }
  if( numSamples <= 0 )
  {
    return 1;
  }

  std::random_device            rd;
  std::mt19937                  gen ( rd() );
  std::discrete_distribution<>  dist( { 6, 5, 3, 2 } );
  const char letters [] =       { 'a', 'b', 'c', 'd' };

  gen.seed();
  for( int k = 0; k < numSamples; k++ )
  {
    std::cout << letters[ dist( gen ) ];
  }

  return 0;
}


